function coifinfo
%COIFINFO Information on coiflets.
%
%   Coiflets Wavelets
%
%   General characteristics: Compactly supported 
%   wavelets with highest number of vanishing 
%   moments for both phi and psi for a given 
%   support width.
%
%   Family                  Coiflets
%   Short name              coif
%   Order N                 N = 1, 2, ..., 5
%   Examples                coif2, coif4
%
%   Orthogonal              yes
%   Biorthogonal            yes
%   Compact support         yes
%   DWT                     possible
%   CWT                     possible
%
%   Support width           6N-1
%   Filters length          6N
%   Regularity              
%   Symmetry                near from
%   Number of vanishing 
%   moments for psi         2N
%   Number of vanishing 
%   moments for phi         2N-1
%
%   Reference: I. Daubechies, 
%   Ten lectures on wavelets, 
%   CBMS, SIAM, 61, 1994, 258-261.

%   M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%   Last Revision: 01-May-1998.
%   Copyright 1995-2002 The MathWorks, Inc.
% $Revision: 1.12 $
