function dbinfo
%DBINFO Information on Daubechies wavelets.
%
%   Daubechies Wavelets
%
%   General characteristics: Compactly supported 
%   wavelets with extremal phase and highest 
%   number of vanishing moments for a given 
%   support width. Associated scaling filters are
%   minimum-phase filters.
%
%   Family                  Daubechies
%   Short name              db
%   Order N                 N strictly positive integer
%   Examples                db1 or haar, db4, db15
%
%   Orthogonal              yes
%   Biorthogonal            yes
%   Compact support         yes
%   DWT                     possible
%   CWT                     possible
%
%   Support width           2N-1
%   Filters length          2N
%   Regularity              about 0.2 N for large N
%   Symmetry                far from
%   Number of vanishing 
%   moments for psi         N
%
%   Reference: I. Daubechies, 
%   Ten lectures on wavelets, 
%   CBMS, SIAM, 61, 1994, 194-202.

%   M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%   Last Revision: 01-May-1998.
%   Copyright 1995-2002 The MathWorks, Inc.
% $Revision: 1.10 $
