function dmeyinfo
%DMEYINFO Information on "Discrete" Meyer wavelet.
%
%   "Discrete" Meyer Wavelet
%
%   Definition: FIR based approximation of the Meyer Wavelet.
%
%   Family                  DMeyer
%   Short name              dmey
%
%   Orthogonal              yes
%   Biorthogonal            yes
%   Compact support         yes
%   DWT                     possible
%   CWT                     possible 
%
%   Reference: P. Abry, 
%   Ondelettes et turbulence, 
%   Diderot ed., Paris, 1997, p. 268.
%
%   See Information on Meyer wavelet.

%   M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 01-Dec-97.
%   Last Revision: 01-May-1998.
%   Copyright 1995-2002 The MathWorks, Inc.
%   $Revision: 1.8 $  $Date: 2002/04/14 19:37:10 $
