function meyrinfo
%MEYRINFO Information on Meyer wavelet.
%
%   Meyer Wavelet
%
%   General characteristics: Infinitely regular orthogonal wavelet.
%
%   Family                  Meyer
%   Short name              meyr
%
%   Orthogonal              yes
%   Biorthogonal            yes
%   Compact support         no
%   DWT                     possible but without FWT
%			    FIR based approximation provides FWT
%   CWT                     possible
%
%   Support width           infinite
%   Effective support       [-8 8]
%   Regularity              indefinitely derivable
%   Symmetry                yes
%
%   Reference: I. Daubechies, 
%   Ten lectures on wavelets, 
%   CBMS, SIAM, 61, 1994, 117-119, 137, 152.
%
%   See Information on "Discrete" Meyer wavelet.   

%   M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%   Last Revision: 01-May-1998.
%   Copyright 1995-2002 The MathWorks, Inc.
% $Revision: 1.10 $

