function morlinfo
%MORLINFO Information on Morlet wavelet.
%
%   Morlet Wavelet
%
%   Definition: 
%   morl(x) = exp(-x^2/2) * cos(5x)
%
%   Family                  Morlet
%   Short name              morl
%
%   Orthogonal              no
%   Biorthogonal            no
%   Compact support         no
%   DWT                     no
%   CWT                     possible
%
%   Support width           infinite
%   Effective support       [-4 4]
%   Symmetry                yes
%
%   Reference: I. Daubechies, 
%   Ten lectures on wavelets, 
%   CBMS, SIAM, 61, 1994, 76.

%   M. Misiti, Y. Misiti, G. Oppenheim, J.M. Poggi 12-Mar-96.
%   Last Revision: 01-May-1998.
%   Copyright 1995-2002 The MathWorks, Inc.
% $Revision: 1.10 $

